#!/bin/ksh
# generate month, week, day CPU graphic
# you may need to change this script to please your need
# WARNING !!! THIS SCRIPT CAN BE VERY LONG TO GENERATE MONTH GRAPHICS
DEBUG=${DEBUG:-"false"}
if $DEBUG; then set -x ; fi

url_nagios="http://nagios-url/display_nagios_info.php"
curl=/usr/local/bin/curl
nagios_cache="/var/www/nagios-cache"
aggregate=1
cpu_indicator="indicator\[\]=iowait&indicator\[\]=sys&indicator\[\]=user"
cpu_limit="min_value=0&max_value=100"
misc="graph_type=cumulate_area&size=1000x300&dump_graphic=1"
date="$(date +%Y%m%d)"
host_list=$($curl $host_list_url 2> /dev/null)
date_format='H:i'

cd $nagios_cache
for period in month day week
do
  echo "$period Generation (start : $(date))..."
  unit="-1+$period+00:00"
  case $period in
    day) aggregate=1 ; date_format='H:i' ; sleep 1 ;;
    week) aggregate=7 ; date_format='d/m' ; sleep 2 ;;
    month) aggregate=31 ; date_format='d/m' ; sleep 5 ;;
  esac
  date_limit="start_date=$unit&end_date=$date+00:00&agregate=$aggregate&date_format=$date_format"
  for host in $host_list
  do
    parameter="name1=$host&name2=CPU"
    printf "%15s : %s" "$host" "$(date +%H:%M:%S)->"
    mkdir -p $host
    $curl "$url_nagios?$parameter&$date_limit&$cpu_limit&$cpu_indicator&$misc" 2> /dev/null > $nagios_cache/$host/CPU-$period-$date.png 
    printf "$(date +%H:%M:%S)\n"
  done
  echo "done ($(date))"
done
